<?php
if (!isset($pagin)) {
	$error = new TukiError('Paginatin print failed', TukiError::ERROR_016);
  $error->throwError();
}
$max = 5;
$count = $pagin->getPagesCount();
$current = $pagin->getPage();
if ($current < $max) {
	$sp = 1; // starting point
} elseif ($current >= $count - floor($max / 2)) {
	$sp = $count - $max + 1;
} elseif ($current >= $max) {
	$sp = $current - floor($max/2);
}
?>
<nav class="box-pagination">
  <ul class="pagination">
    <?php if ($sp > 1) { ?>
      <li class="page-item">
        <a class="page-link" href="<?= $pagin->getPageUrl(1) ?>">1</a>
      </li>
      <li class="page-item disabled">
        <span class="page-link">
          ... 
        </span>
      </li>
    <?php } ?>
    <?php for ($i = $sp; $i <= ($sp + $max -1); $i++) { ?>
      <?php if ($i > $count)	continue; ?>
      <li class="page-item <?= $i == $current ? 'active' : '' ?>">
        <a class="page-link" href="<?= $pagin->getPageUrl($i) ?>"><?= $i ?></a> 
      </li>
    <?php } ?>
    <?php if ($i <= $count) { ?>
        <li class="page-item disabled">
          <span class="page-link">
            ... 
          </span>
        </li>
        <li class="page-item">
          <a class="page-link" href="<?= $pagin->getPageUrl($count) ?>"><?= $count?></a> 
        </li>
    <?php } ?>
  </ul>
</nav>